
//*****************************************************************************/
// Existing functions in the main windows.

messageHeaderSink.onEndHeaders = function() {
  if (TM.v.toggleRemoteContentAllow)
    return;
TM.u.log.debug("messageHeaderSink.onEndHeaders: START");
  // Give add-ons a chance to modify currentHeaderData before it actually
  // gets displayed.
  for (let index in gMessageListeners)
    if ("onBeforeShowHeaderPane" in gMessageListeners[index])
      gMessageListeners[index].onBeforeShowHeaderPane();

  if (!FeedMessageHandler.shouldShowSummary(gMessageDisplay.displayedMessage, false))
    FeedMessageHandler.setContent(gMessageDisplay.displayedMessage, false);

  ShowMessageHeaderPane();

  gMessageNotificationBar.setDraftEditMessage();
  UpdateJunkButton();
  UpdateReplyButtons();
  displayAttachmentsForExpandedView();

  for (let index in gMessageListeners)
    gMessageListeners[index].onEndHeaders();
TM.u.log.debug("messageHeaderSink.onEndHeaders: FINISH");
};

messageHeaderSink._onStartHeaders = messageHeaderSink.onStartHeaders;
messageHeaderSink.onStartHeaders = function() {
TM.u.log.debug("messageHeaderSink.onStartHeaders: START ");

  this._onStartHeaders();
};
/*
messageHeaderSink._onEndMsgDownload = messageHeaderSink.onEndMsgDownload;
messageHeaderSink.onEndMsgDownload = function(url) {
TM.u.log.debug("messageHeaderSink.onEndMsgDownload: START ");

  this._onEndMsgDownload(url);
TM.u.log.debug("messageHeaderSink.onEndMsgDownload: END ");
};
*/
function ReloadMessage() {
TM.u.log.debug("ReloadMessage: ");
  // Reset our load flags.
  TM.resetMsgLoadFlags();
  TM.v.saveShowHeaders = Services.prefs.getIntPref("mail.show_headers");

  // If the current message was loaded from a file or attachment, so the dbView
  // can't handle reloading it. Let's do it ourselves, instead.
  if (TM.u.winType == "mail:messageWindow" &&
      window.arguments[0] instanceof Components.interfaces.nsIURI)
    gMessageDisplay.displayExternalMessage(window.arguments[0].spec);
  else
    gFolderDisplay.view.dbView.reloadMessage();
}

nsContextMenu.prototype._TM_initItems = nsContextMenu.prototype.initItems;
nsContextMenu.prototype.initItems = function() {
  // Run this first, so separator handling is correct.
  this.initTotalMessageItems();

  this._TM_initItems();
};

nsContextMenu.prototype.initTotalMessageItems = function() {
  // This isn't initialized, so avoid a warning.
  this.onEditableArea = false;

  // Don't want anything but text copy/select on non link contextmenu in headers.
  this.docURL = null;
  if (document.popupNode)
    this.docURL = document.popupNode.ownerDocument.URL;
  this.hideMailItems = this.docURL == TM.v.headersUrl;

  // So our editor can get all the menuitems for an editable area...
  if (document.popupNode instanceof HTMLTextAreaElement &&
      !document.popupNode.readOnly)
    this.inMessageArea = false;

  // Only show CustomizeToolbarMenuItem if we're in headers bar.
  let onHeaders = this.docURL == TM.v.headersUrl;
  this.showItem("CustomizeHeadersMenuItem", onHeaders);
  this.showItem("EnableHeaderEditModeMenuItem", onHeaders);

  // Disable EnableHeaderEditModeMenuItem if not editable.
  this.setItemAttr("EnableHeaderEditModeMenuItem", "disabled", !TM.Headers.isEditable());

  // No mailitems on a messagepane content link or in headers pane.
  this.hideMailItems = this.onLink || onHeaders;

  // Only show mailContext-openLinkInContent[Tab|Win|MessagePane] if we're on a link and
  // link and it isn't a mailto link.
  this.showItem("mailContext-openLinkInContentTab",
                this.onLink && !this.onMailtoLink &&
                this.linkProtocol != "about" && this.linkProtocol != "chrome");
  this.showItem("mailContext-openLinkInContentWin",
                this.onLink && !this.onMailtoLink &&
                this.linkProtocol != "about" && this.linkProtocol != "chrome");
  this.showItem("mailContext-openLinkInMessagePane",
                this.onLink && !this.onMailtoLink &&
                this.linkProtocol.startsWith("http"));

  // Work out if we are a context menu on a special item e.g. an image, link, etc.
  let notOnSpecialItem = !(this.inMessageArea || this.isContentSelected ||
                           this.onCanvas || this.onLink || this.onImage ||
                           this.onPlayableMedia || this.onTextInput);

  // Ensure these commands are updated with their current status.
  if (notOnSpecialItem) {
    goUpdateCommand("Browser:Back_TM");
    goUpdateCommand("Browser:Forward_TM");
  }
  // These only needs showing if we're not on something special.
  this.showItem("context-back_TM", notOnSpecialItem);
  this.showItem("context-forward_TM", notOnSpecialItem);
};

// Hard coded separators?  Fix..
nsContextMenu.prototype.initSeparators = function() {
  let mailContextSeparators = [];
  let separatorNodes = this.menu.getElementsByTagName("menuseparator");
  for (let separatorNode of separatorNodes)
    if (separatorNode.id)
      mailContextSeparators.push(separatorNode.id);

  mailContextSeparators.forEach(this.hideIfAppropriate, this);

  this.checkLastSeparator(this.menu);
};

/**
 * Open a link in Tb, via contextmenu.
 *
 * @param   object aEvent   - event.
 * @param   string aWhere   - 'tab' or 'window'.
 */
nsContextMenu.prototype.openLinkInContentTabWin = function(aEvent, aWhere) {
TM.u.log.debug("TM.openLinkInContentTabWin: START url - "+ this.linkURI.spec);
  let bgLoad = Services.prefs.getBoolPref("mail.tabs.loadInBackground");
  if (aEvent.shiftKey)
    bgLoad = !bgLoad;

  aWhere = aWhere == "window" ? "window" : "tab";
  bgLoad = aWhere == "window" ? false : bgLoad;
  openTab("contentTab",
          { contentPage: this.linkURI.spec,
            clickHandler: "specialTabs.siteClickHandler(event, new RegExp(\"^\"));",
            background: bgLoad },
          aWhere);
};

/**
 * In 3pane only. Support drag and drop rethreading of messages.
 */
if ("ThreadPaneOnDragStart" in window) {
  TM.Headers._ThreadPaneOnDragStart = ThreadPaneOnDragStart;
  ThreadPaneOnDragStart = TM.Headers.ThreadPaneOnDragStart;

  TM.Headers._ThreadPaneOnDragOver = ThreadPaneOnDragOver;
  ThreadPaneOnDragOver = TM.Headers.ThreadPaneOnDragOver;

  TM.Headers._ThreadPaneOnDrop = ThreadPaneOnDrop;
  ThreadPaneOnDrop = TM.Headers.ThreadPaneOnDrop;
}

/**
 * FolderDisplayWidget tells us when a message is being displayed.
 */
MessageDisplayWidget.prototype.onDisplayingMessage = function(aMsgHdr) {
TM.u.log.debug("MessageDisplayWidget.onDisplayingMessage: START ");
  if (!TM.u.messageHeaderContentDocument ||
      TM.u.messageHeaderContentDocument.URL == "about:blank")
    TM.u.messageHeader.loadURI(TM.v.headersUrl);

  this.displayedMessage = aMsgHdr;
  this.onLoadStarted();

  // We need all the headers.
  Services.prefs.setIntPref("mail.show_headers", 2);
}

/**
 * No select on delete/move/archive if no message selected/message unselected,
 * even across folder changes and selects/unselects and actions. Make sure
 * ctrl-click unselect clears |lastMessageLoaded|.
 */
FolderDisplayWidget.prototype._updateCommandStatus = FolderDisplayWidget.prototype.updateCommandStatus;
FolderDisplayWidget.prototype.updateCommandStatus = function() {
  if (gDBView && gDBView.selection && gDBView.selection.count == 0 &&
      this.view.displayedFolder)
    this.view.displayedFolder.lastMessageLoaded = nsMsgKey_None;

  this._updateCommandStatus();
  };
FolderDisplayListenerManager.registerListener({
  onMessagesRemoved: function(aFolderDisplay) {
    if (aFolderDisplay.view.displayedFolder &&
        aFolderDisplay.view.displayedFolder.lastMessageLoaded == nsMsgKey_None) {
      aFolderDisplay._nextViewIndexAfterDelete = -1;
      aFolderDisplay._mostRecentSelectionCounts[1] = 0;
    }
    else if (gDBView && gDBView.selection.count > 0) {
      aFolderDisplay._nextViewIndexAfterDelete = gDBView.selection.currentIndex;
    }
  },
})

function findEmailNodeFromPopupNode(elt, popup) {
  return TM.u.g(popup).anchorNode;
};

function setupEmailAddressPopup(emailAddressNode) {
  let emailAddressPlaceHolder = document.getElementById('emailAddressPlaceHolder');
////  let emailAddress = emailAddressNode.getPart('emaillabel').value;
  let emailAddress = emailAddressNode.getAttribute("fullAddress");
  emailAddressNode.setAttribute('selected', 'true');
  emailAddressPlaceHolder.setAttribute('label', emailAddress);

  if (emailAddressNode.cardDetails.card) {
    document.getElementById('addToAddressBookItem').setAttribute('hidden', true);
    if (!emailAddressNode.cardDetails.book.readOnly) {
      document.getElementById('editContactItem').removeAttribute('hidden');
      document.getElementById('viewContactItem').setAttribute('hidden', true);
    }
    else {
      document.getElementById('editContactItem').setAttribute('hidden', true);
      document.getElementById('viewContactItem').removeAttribute('hidden');
    }
  }
  else {
    document.getElementById('addToAddressBookItem').removeAttribute('hidden');
    document.getElementById('editContactItem').setAttribute('hidden', true);
    document.getElementById('viewContactItem').setAttribute('hidden', true);
  }
};

function OnAddressBookDataChanged(aAction, aParentDir, aItem) {
//TM.u.log.info("OnAddressBookDataChanged: START ");
  gEmailAddressHeaderNames.forEach(function (headerName) {
//TM.u.log.info("OnAddressBookDataChanged: headerName "+headerName);
    let headerNameAddresses = TM.u.c(TM.u.messageHeader, "messageHeaderBody")
                                .getElementsByClassName(headerName);

    for (let addressNode of headerNameAddresses) {
      if (!addressNode.classList.contains("emailAddress"))
        // The header name must only exist in the <a> tag classlist which must
        // also contain 'emailAddress' as a check.
        continue;

      let addressData = {};
      addressData["emailAddress"] = addressNode.getAttribute("emailAddress");
      addressData["displayName"] = addressNode.getAttribute("displayName");
      addressData["fullAddress"] = addressNode.getAttribute("fullAddress");
//TM.u.log.info("OnAddressBookDataChanged: addressNode "+addressNode.className);
//TM.u.log.info("OnAddressBookDataChanged: addressData "+addressData.toSource());

      this.UpdateExtraAddressProcessing(addressData, addressNode,
                                        aAction, aParentDir, aItem);

      // Fix up the tooltip if ab card changed.
      addressNode.nextElementSibling.title = addressNode.getAttribute("tooltipstar");
    }
  }, this);
};

TM._ToggleMessageTagMenu = ToggleMessageTagMenu;
ToggleMessageTagMenu = function(aTarget) {
  TM._ToggleMessageTagMenu(aTarget);

  // Reflect the new tag state.
  TM.u.mainWindow.TM.resetHeaderFlags();
  TM.u.mainWindow.TM.Headers.toggle();
};

TM._HandleMultipleAttachments = HandleMultipleAttachments;
HandleMultipleAttachments = function(attachments, action) {
  // Feed enclosures need special handling for 'save' and 'save as'.
  if (TM.v.msgHdr.flags & Ci.nsMsgMessageFlags.FeedMsg &&
      (action == "save" || action == "saveAs")) {
    TM.Attachments.saveLinkAttachmentsToFile(attachments);
    return;
  }

  TM._HandleMultipleAttachments(attachments, action);
};

function CustomizeMailToolbar(toolboxId, customizePopupId) {
TM.u.log.debug("CustomizeMailToolbar: toolboxId - "+toolboxId);
  // Disable the toolbar context menu items.
  let menubar = document.getElementById("mail-menubar");
  for (let childNode of menubar.childNodes)
    childNode.setAttribute("disabled", true);

  let customizePopup = document.getElementById(customizePopupId);
  customizePopup.setAttribute("disabled", "true");

  let toolbox = document.getElementById(toolboxId);

  if (toolboxId == "header-view-toolbox") {
    let palette = toolbox.palette;
    toolbox = TM.u.c(TM.u.messageHeader, "header-view-toolbox");
    toolbox.palette = palette;
  }

  let customizeURL = "chrome://global/content/customizeToolbar.xul";
  gCustomizeSheet = Services.prefs.getBoolPref("toolbar.customization.usesheet");

  if (gCustomizeSheet) {
    let sheetFrame = document.getElementById("customizeToolbarSheetIFrame");
    let panel = document.getElementById("customizeToolbarSheetPopup");
    sheetFrame.hidden = false;
    sheetFrame.toolbox = toolbox;
    sheetFrame.panel = panel;

    // The document might not have been loaded yet, if this is the first time.
    // If it is already loaded, reload it so that the onload intialization code
    // re-runs.
    if (sheetFrame.getAttribute("src") == customizeURL)
      sheetFrame.contentWindow.location.reload()
    else
      sheetFrame.setAttribute("src", customizeURL);

    // Open the panel, but make it invisible until the iframe has loaded so
    // that the user doesn't see a white flash.
    panel.style.visibility = "hidden";
    toolbox.addEventListener("beforecustomization", function () {
      toolbox.removeEventListener("beforecustomization", arguments.callee, false);
      panel.style.removeProperty("visibility");
    }, false);
    panel.openPopup(toolbox, "after_start", 0, 0);
  }
  else {
    let wintype = document.documentElement.getAttribute("windowtype");
    wintype = wintype.replace(/:/g, "");

    window.openDialog(customizeURL,
                      "CustomizeToolbar"+wintype,
                      "chrome,all,dependent", toolbox);
  }

  if (toolboxId == "header-view-toolbox")
    setTimeout(function() { TM.Headers.setToolbarState(); }, 100);
};

//*****************************************************************************/
// Threadpane functions.

if ("ThreadPaneSelectionChanged" in window) {
  TM.List._ThreadPaneSelectionChanged = ThreadPaneSelectionChanged;
  ThreadPaneSelectionChanged = function(aEvent) {
TM.u.log.debug("ThreadPaneSelectionChanged: START ");
    if (TM.u.HEADER_LIST_ENABLED && !gFolderDisplay)
      return;

    TM.List._ThreadPaneSelectionChanged();
  };
}

if ("HandleColumnClick" in window) {
  HandleColumnClick = TM.List.handleColumnClick;
}

if ("MsgSortThreadPane" in window) {
  MsgSortThreadPane = function(sortName) {
TM.u.log.debug("MsgSortThreadPane: START sortName - "+sortName);
    // legacy behavior dictates we un-group-by-sort if we were.  this probably
    //  deserves a UX call...
    if (gFolderDisplay.view.showGroupedBySort) {
      gFolderDisplay.view.showGroupedBySort = false;
      TM.List.Sorting = false;
    }

    gFolderDisplay.view.sort(nsMsgViewSortType[sortName], gDBView.sortOrder);
  };
}

if ("UpdateSortIndicators" in window) {
  TM.List._UpdateSortIndicators = UpdateSortIndicators;
  UpdateSortIndicators = function(sortType, sortOrder) {

    if (gFolderDisplay && !gFolderDisplay._tabInfo.mode.legalPanes.thread)
      // Not a view with threadpane, bye.
      return;

    if (TM.u.HEADER_LIST_ENABLED && TM.List.Sorting)
      return;

    TM.List._UpdateSortIndicators(sortType, sortOrder);

    if (!TM.u.HEADER_LIST_ENABLED || !TM.List._initialized)
      return;

TM.u.log.debug("UpdateSortIndicators: START sortType:dbView.sortType:primarySortType - "+
               sortType+":"+gDBView.sortType+":"+gFolderDisplay.view.primarySortType);
TM.u.log.debug("UpdateSortIndicators: START sortOrder:dbView.sortOrder:primarysortOrder - "+
               sortOrder+":"+gDBView.sortOrder+":"+gFolderDisplay.view.primarySortOrder);

    TM.List.sortByPopup(TM.u.d("tmSortByPopup"), sortType, sortOrder);
    TM.List.sortByPopup(TM.u.d("tmSortBy2Popup"), sortType, sortOrder);
    TM.List.sortGroupPopup();
  };
}
