
if (typeof(TM) == "undefined")
  var TM = {};

TM.Preferences = {
  d: function(elementId) { return document.getElementById(elementId); },
  get TM()               { return Services.wm.getMostRecentWindow("mail:3pane").TM; },
  get tmPanel()          { return this.d("totalMessagePanel"); },
  get tmPanelBox()       { return this.d("headersPanelBox"); },
  get headersTree()      { return this.d("headersTree"); },
  get headerMapListBox() { return this.d("headerMapListBox"); },

  get messageType() {
//this.TM.u.log.debug("TM.Preferences.messageType: "+menulist.selectedItem.value);
    if (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE])
      return this.TM.v.HEADER.MSG_TYPE_MAIL;
    return this.d("headerMessageTypeMenuList").selectedItem.value;
  },

  get headerType() {
//this.TM.u.log.debug("TM.Preferences.headerType: "+this.d("headerTypeMenuList").selectedItem.value);
    return this.d("headerTypeMenuList").selectedItem.value;
  },

  get headerMap() {
    return this._headerMap ? this._headerMap :
           this._headerMap = this.TM.u.getHeaderMap(this.messageType);
  },

  get headerMapDefault() {
    if (this._headerMapDefault)
      return this._headerMapDefault;
    let defaultMapName = "headerMap" + this.messageType + "Default";
    if (this.TM.v[defaultMapName])
      return this._headerMapDefault = this.TM.v[defaultMapName];
    return this._headerMapDefault = this.TM.v["headerMapMailDefault"];
  },

  onPaneLoad: function() {
    let self = this;
self.TM.u.log.debug("TM.Preferences.onPaneLoad: LOAD paneDisplay.loaded:gDisplayPane.mInitialized "+
                    self.d("paneDisplay").loaded+":"+gDisplayPane.mInitialized);
    setTimeout(function() {
      // The overlay of our large widget creates a timing issue as fonts/tags
      // panels are not initialized properly in the prefwindow constructor.
      // Ensure gDisplayPane.init() is run.
      let paneDisplay = self.d("paneDisplay");
      if (paneDisplay && paneDisplay.loaded && !gDisplayPane.mInitialized)
        gDisplayPane.init();
self.TM.u.log.debug("TM.Preferences.onPaneLoad: START paneDisplay.loaded:gDisplayPane.mInitialized "+
                    paneDisplay.loaded+":"+gDisplayPane.mInitialized);

      try {
//        if (Services.prefs.getBoolPref("mail.preferences.inContent"))
        if (self.d("MailPreferences").tagName == "preftab")
          self.d("MailPreferences").classList.add("incontent");
      }
      catch(ex) {}

      self.init();
      self.createMap();
      // Restore open rows.
      self.restoreOpenState();
      self.reflow();
    }, 100);
  },

  onSelectDisplayPrefsTab: function(aDisplayTabs) {
this.TM.u.log.debug("TM.Preferences.onSelectDisplayPrefsTab: START "+aDisplayTabs.selectedItem.id);
    if (aDisplayTabs.selectedItem.id == "totalMessageTab")
      this.d("MailPreferences").setAttribute("totalMessageTab", true);
    else
      this.d("MailPreferences").removeAttribute("totalMessageTab");
  },

  onSelectBox: function(aEvent) {
    // Select in headers tree or listbox, or listbox header button oncommand.
this.TM.u.log.debug("TM.Preferences.onSelectBox: START target - "+aEvent.target.id);
    TM.Preferences.updateButtonState();
  },

  onSelectTree: function(aEvent) {
    // Select in headers tree or listbox, or listbox header button oncommand.
this.TM.u.log.debug("TM.Preferences.onSelectTree: START ");
    TM.Preferences.updateButtonState();
  },

  onClick: function(aEvent) {
    // Click on treechildren.
    if (aEvent.button != 0)
      return;
this.TM.u.log.debug("TM.Preferences.onClick: START ");
    let row = { }, col = { }, element = { }, val;
    this.treeBox.getCellAt(aEvent.clientX, aEvent.clientY, row, col, element);
    let colId = col.value.id;
    if (row.value == -1 || element.value == "twisty" ||
        (colId != "wrapCol" && colId != "ellipsisCol"))
      return;

this.TM.u.log.debug("TM.Preferences.onClick: element "+element.value+":"+row.value+":"+col.value.id);

    let headerIndex = colId == "wrapCol" ? this.TM.v.kWrapLines : this.TM.v.kEllipsis;
    let headerName = this.visibleArray[row.value][this.kName];
    let [headerCategory, headerValue] = this.getHeaderValue(headerName);

    if (headerValue) {
      if (!headerValue[this.TM.v.kMapped])
        // Don't edit unmapped headers unless it's composeHeader.
        return;

      if (headerIndex == this.TM.v.kWrapLines)
        headerValue[this.TM.v.kWrapLines] = headerValue[this.TM.v.kWrapLines] ? 0 : 1;
      else
        headerValue[headerIndex] = !headerValue[headerIndex];
//      this[headerCategory].set(headerName, headerValue);
      this.treeBox.invalidateRow(row.value);
    }
    else
      this.TM.u.log.warn("TM.Preferences.onClick: header not found - "+headerName);
  },

  init: function() {
this.TM.u.log.debug("TM.Preferences.init: START ");
    for (let id of ["headerTypeMenuList", "headerMessageTypeMenuList"]) {
      let ml = this.d(id);
      let selector = "menuitem[value='" + ml.getAttribute("value") + "']";
      ml.selectedItem = ml.querySelectorAll(selector)[0];
this.TM.u.log.debug("TM.Preferences.init: "+id+" - "+ml.selectedItem.value);
    }

    // Fill in prefs.
    this.d("separatorChar").value = this.TM.u.HEADER_SEP;
    this.d("wrapLines").value     = this.TM.u.HEADER_WRAP_LINES;
    this.d("autoCollect").checked = this.TM.u.AUTOCOLLECT_ACTIVE;
    // Set up strings.
    this["commonHeadersStr"]      = this.TM.u.strings.get("commonHeaders");
    this["collectedHeadersStr"]   = this.TM.u.strings.get("collectedHeaders");
    this["customHeadersStr"]      = this.TM.u.strings.get("customHeaders");
    this["otherValuesStr"]        = this.TM.u.strings.get("otherValues");
    this["textStr"]               = this.TM.u.strings.get("text");
    this["emailStr"]              = this.TM.u.strings.get("email");
    this["messageidStr"]          = this.TM.u.strings.get("messageid");
    this["newsgroupStr"]          = this.TM.u.strings.get("newsgroup");
    this["linkStr"]               = this.TM.u.strings.get("link");
    this["editDiplayNameKey"]     = this.TM.u.strings.get("editDiplayNameKey");
    this["editFormatKey"]         = this.TM.u.strings.get("editFormatKey");
    this["toggleWrapKey"]         = this.TM.u.strings.get("toggleWrapKey");
    this["toggleEllipsisKey"]     = this.TM.u.strings.get("toggleEllipsisKey");
//    this["toggleComposeColKey"] = "c"; //this.TM.u.strings.get("toggleComposeColKey");

    this.setHeaderType();

    // Set the headersTree view.
    this.headersTree.view = this;
this.TM.u.log.debug("TM.Preferences.init: rowcount - "+ this.headersTree.view.rowCount);
  },

  reflow: function() {
this.TM.u.log.debug("TM.Preferences.reflow: START ");
    setTimeout(function() {
                 TM.Preferences.TM.Headers.setToolbarState();
                 TM.Preferences.TM.Headers.setWrapState();
               }, 100);
  },

  restoreOpenState: function() {
this.TM.u.log.debug("TM.Preferences.restoreOpenState: START ");
    let openbits = parseInt(this.headersTree.getAttribute("openbits"));
    for (let row of this.visibleArray) {
      if (row[this.kIsContainer] && openbits & row[this.kOpenBit])
        this.toggleOpenState(this.getRowForCategory(row[this.kCategoryName]));
    }
  },

  setOpenState: function() {
this.TM.u.log.debug("TM.Preferences.setOpenState: START ");
    let openbits = 0;
    for (let row of this.visibleArray) {
      if (row[this.kIsOpen])
        openbits += row[this.kOpenBit];
    }
    this.headersTree.setAttribute("openbits", openbits);
this.TM.u.log.debug("TM.Preferences.setOpenState: set openbits - "+openbits);
  },

  updateButtonState: function() {
this.TM.u.log.debug("TM.Preferences.updateButtonState: START ");
    let listbox = this.headerMapListBox;
    let listboxSelected = listbox.selectedCount > 0;
    let headerstreeSelected = this.headersTree.view &&
                              this.headersTree.view.selection.count > 0;

    if (listboxSelected && listbox.hasAttribute("hasemptyrow") &&
        !listbox.selectedItem.hasAttribute("emptyrow")) {
      // Delete empty non selected row, should only ever be one at this point.
      this.removeRow(listbox.querySelector("listitem[emptyrow]"));
      listbox.removeAttribute("hasemptyrow");
    }

    if (listboxSelected) {
      if (this.headerType != this.TM.v.HEADER[this.TM.v.HEADER.LIST]) {
        if (listbox.hasAttribute("hasemptyrow"))
          this.d("addRowButton").setAttribute("disabled", true);
        else
          this.d("addRowButton").removeAttribute("disabled");
      }
      else {
        this.d("addRowButton").setAttribute("disabled", true);
      }
      this.d("removeRowOrHeaderButton").removeAttribute("disabled");
    }
    else {
      this.d("addRowButton").setAttribute("disabled", true);
      this.d("removeRowOrHeaderButton").setAttribute("disabled", true);
    }

    let treeRow = this.headersTree.currentIndex;
//this.TM.u.log.debug("TM.Preferences.updateButtonState: treeRow - "+treeRow);
    if (headerstreeSelected && !this.isContainer(treeRow) &&
        this.getParentIndex(treeRow) != this.getRowForCategory("commonHeaders"))
      this.d("deleteHeaderButton").removeAttribute("disabled");
    else
      this.d("deleteHeaderButton").setAttribute("disabled", true);

    let isNotNewsListHeader = false;
    if (treeRow >= 0 &&
        (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.LIST] ||
         this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.LISTMR]) &&
        this.messageType == this.TM.v.HEADER.MSG_TYPE_NEWS) {
      // No headers for remote nntp except from msgHdr/cols.
      let headerName = this.visibleArray[treeRow][this.kName];
      let colId = this.TM.u.commonHeaders.has(headerName) ?
                    this.TM.u.commonHeaders.get(headerName)[this.TM.v.kColId] :
                  this.TM.u.otherValues.has(headerName) ?
                    this.TM.u.otherValues.get(headerName)[this.TM.v.kColId] : null;
      isNotNewsListHeader = colId ? false : true;
    }

    if (headerstreeSelected && !this.isContainer(treeRow) && !isNotNewsListHeader)
      this.d("addHeaderToMapButton").removeAttribute("disabled");
    else
      this.d("addHeaderToMapButton").setAttribute("disabled", true);
  },


/* Headers map listbox functions **********************************************/

  createMap: function() {
this.TM.u.log.debug("TM.Preferences.createMap: START Map="+this.headerMap.toSource());
    // Clear old list.
    this.headerMapListBox.removeAttribute("hasemptyrow");
    for (let listitem of this.headerMapListBox.querySelectorAll("listitem"))
      listitem.remove();

    if (!(this.headerType in this.headerMap))
      // For v2 headerType additions not in current user set maps.
      this.headerMap[this.headerType] = this.headerMapDefault[this.headerType];

    // Create categories.
    this.categories.map(headerCategory => this.getHeadersCategory(headerCategory));

    for (let [row, headerRow] in Iterator(this.headerMap[this.headerType])) {
this.TM.u.log.debug("TM.Preferences.createMap: type:row#:rowValue - "+
                    this.headerType+":"+row+":"+headerRow.toSource());
      let headerListitem = this.createBlankListitem();

      for (let [headerName, headerValue] in Iterator(headerRow)) {
this.TM.u.log.trace("TM.Preferences.createMap: headerName - "+headerName);
        if (this.headerExists(headerName))
          // A header in the map may have been deleted from the headers list,
          // don't add it to the listbox.
          headerListitem.firstChild.firstChild
                        .appendChild(this.createHeaderContainer(headerName));
      }

      if (headerListitem.firstChild.firstChild.hasChildNodes())
        this.headerMapListBox.appendChild(headerListitem);
    }

    // Force listbox horizontal scroll, ridiculous hoop jumping!!
    this.fixIdioticForcedScrollHidden();
  },

  createHeaderContainer: function(aName) {
this.TM.u.log.debug("TM.Preferences.createHeaderContainer: START "+aName);
    let headerContainer = document.createElementNS(this.TM.v.XUL_NS, "button");
    headerContainer.classList.add("header-button");
    headerContainer.setAttribute("label", aName);
    headerContainer.setAttribute("type", "checkbox");
    return headerContainer;
  },

  addHeader: function(aHeaderName) {
this.TM.u.log.debug("TM.Preferences.addHeader: START headername - "+aHeaderName); //+":"+this.rowCount);
    let headerName = aHeaderName ? aHeaderName.trim() : "";

    let [headerCategory, headerValue] = this.getHeaderValue(headerName);
    if (headerValue)
      // Already exists.
      return;
//this.TM.u.log.debug("TM.Preferences.addHeader: rowcount1 - "+ this.TM.Preferences.headersTree.view.rowCount);
this.TM.u.log.debug("TM.Preferences.addHeader: rowcount2 - "+ this.headersTree.view.rowCount);

    headerCategory = "customHeaders";
    let customHeaderRow = this.getRowForCategory(headerCategory);
    let newHeader = [].concat(this.headerValueTemplate);
    let updateHeadersSet = this.TM.u[headerCategory];
    updateHeadersSet.add(headerName);
    this.TM.u[headerCategory] = updateHeadersSet;
    this[headerCategory].set(headerName, newHeader);
this.TM.u.log.debug("TM.Preferences.addHeader: row:visarray - "+
                    customHeaderRow+":"+this.visibleArray[customHeaderRow]);

    this.headersTree.view.selection.selectEventsSuppressed = true;
    this.treeBox.ensureRowIsVisible(customHeaderRow);
    if (this.visibleArray[customHeaderRow][this.kIsOpen])
      // If folder open, close it.  An open builds the new list.
      this.toggleOpenState(customHeaderRow);
    this.toggleOpenState(customHeaderRow);
//    this.headersTree.view.selection.selectEventsSuppressed = false;
//    this.treeBox.invalidate();
    let row = this.headersTree.view.rowCount - 1;
    let col = this.headersTree.columns.getNamedColumn("nameCol");
    this.treeBox.scrollToRow(row);
    this.treeBox.ensureRowIsVisible(customHeaderRow);
    this.isNameColEditable = false;
    this.headersTree.view.selection.select(row);
    this.headersTree.view.selection.selectEventsSuppressed = false;

    if (!aHeaderName) {
this.TM.u.log.debug("TM.Preferences.addHeader: START editor ");
      // Start the editor if not passed in the new name of the just edited row.
      this.isNameColEditable = true;
      this.headersTree.startEditing(row, col);
    }
  },

  deleteHeader: function(aHeaderName) {
this.TM.u.log.debug("TM.Preferences.deleteHeader: START headername - "+aHeaderName);
    if (!aHeaderName && !this.headersTree.view.selection.count)
      return;

    let headerName, row, containerRow;
    let scrollToRow = this.treeBox.getFirstVisibleRow();

    if (aHeaderName)
      headerName = aHeaderName;
    else if (this.isNameColEditable)
      // In custom header editor and clicked somewhere to select a random row
      // with a blank custom headername.
      headerName = aHeaderName;
    else {
      row = this.headersTree.currentIndex;
      headerName = this.visibleArray[row][this.kName];
    }

    let [headerCategory, headerValue] = this.getHeaderValue(headerName);
    let updateHeadersSet = this.TM.u[headerCategory];
    updateHeadersSet.delete(headerName);
    this.TM.u[headerCategory] = updateHeadersSet;
    this[headerCategory].delete(headerName);

this.TM.u.log.debug("TM.Preferences.deleteHeader: headerCategory:headerName:headerValue - "+
                    headerCategory+":"+headerName+":"+headerValue);
this.TM.u.log.trace("TM.Preferences.deleteHeader: headerCategory pref - "+
                    JSON.stringify([...this.TM.u[headerCategory]]));
this.TM.u.log.trace("TM.Preferences.deleteHeader: headerCategory cache - "+
                    JSON.stringify([...this[headerCategory]]));

    // Back to the tree.
    if (this.isNameColEditable) {
      // Deleting our pseudo placeholder row, only in customHeaders folder.
      containerRow = row = this.getRowForCategory("customHeaders");
      row = this.headersTree.view.rowCount - 1;
    }
    else {
      // Deleting selected row, not our pseudo placeholder row.
      containerRow = this.getParentIndex(row);
    }

    this.headersTree.view.selection.selectEventsSuppressed = true;
    this.toggleOpenState(containerRow);
    this.toggleOpenState(containerRow);
    row = row < this.headersTree.view.rowCount ? row : row - 1;
    this.headersTree.view.selection.select(row);
this.TM.u.log.debug("TM.Preferences.deleteHeader: row - "+row);
//    this.headersTree.currentIndex = row;
    this.treeBox.scrollToRow(scrollToRow);
    this.headersTree.view.selection.selectEventsSuppressed = false;

this.TM.u.log.debug("TM.Preferences.deleteHeader: currentIndex - "+this.headersTree.currentIndex);

    // Delete header from listbox map.
    let anyMapped = this.headerMapListBox
                        .querySelectorAll('button[label="' + headerName + '"]');
    for (let mapped of anyMapped) {
      let rowNode = mapped.parentNode.parentNode.parentNode;
      mapped.remove();
      if (!rowNode.firstChild.firstChild.hasChildNodes()) {
        // This row is now empty.  Set hasemptyrow to make sure all rows are
        // deleted (unlike deleting multiselection items in the listbox, where
        // one empty row remains).
        rowNode.setAttribute("emptyrow", true);
        this.headerMapListBox.setAttribute("hasemptyrow", true);
        this.handleEmptyRow(rowNode);
      }
    }

    // Finally, delete the header from all maps and save.
    // TODO:
  },

  addHeaderToMap: function() {
this.TM.u.log.debug("TM.Preferences.addHeaderToMap: START ");
    if ((this.headerType != this.TM.v.HEADER[this.TM.v.HEADER.LIST] &&
         !this.headerMapListBox.selectedItem) ||
        (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.LIST] &&
         !this.headerMapListBox.getItemAtIndex(0)) ||
        (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE] &&
         !this.headerMapListBox.hasAttribute("hasemptyrow")))
      this.addBlankListitem();

    let row = this.headersTree.currentIndex;
    let headerName = this.visibleArray[row][this.kName];
    let button = this.createHeaderContainer(headerName);
    if (!this.headerMapListBox.selectedItem)
      this.headerMapListBox.selectItem(this.headerMapListBox.getItemAtIndex(0));
    this.headerMapListBox.selectedItem.firstChild.firstChild.appendChild(button);

    let [headerCategory, headerValue] = this.getHeaderValue(headerName);
    headerValue[this.TM.v.kMapped] = true;
    // Auto create displayName first time for categories with no defaults;
    // capitalize words per convention.
    if (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE] ||
        (!this.TM.headerDisplaySpecial(this.messageType, headerName) &&
         headerValue[this.TM.v.kDisplayName] !== null &&
         headerCategory != "commonHeaders" &&
         headerCategory != "otherValues")) {
      let sep = this.headerType != this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE] ?
                  this.TM.u.HEADER_SEP : "";
      let sepL = "", sepR = "";
      this.TM.u.isRtl ? sepL = sep : sepR = sep;
      let displayName = sepL +
                        headerName.replace(/(^|-)[a-z]/g, h => h.toUpperCase()) +
                        sepR;
      headerValue[this.TM.v.kDisplayName] = displayName;
    }

this.TM.u.log.debug("TM.Preferences.addHeaderToMap: B headerCategory:headerName:headerValue - "+
                    headerCategory+":"+headerName+":"+headerValue);
//this.TM.u.log.debug("TM.Preferences.addHeaderToMap: headerCategory cache2 - "+
//                    JSON.stringify([...this[headerCategory]]));
    this.treeBox.invalidateRow(row);

    if (this.headerMapListBox.selectedItem.hasAttribute("emptyrow")) {
      this.headerMapListBox.removeAttribute("hasemptyrow");
      this.headerMapListBox.selectedItem.removeAttribute("emptyrow");
    }

    this.updateButtonState();
    this.d("undoButton").removeAttribute("disabled");
  },

  addRow: function() {
this.TM.u.log.debug("TM.Preferences.addRow: START ");
    this.addBlankListitem();
    this.updateButtonState();
    this.d("undoButton").removeAttribute("disabled");
  },

  addBlankListitem: function() {
this.TM.u.log.debug("TM.Preferences.addBlankListitem: START ");
    let node = this.headerMapListBox.selectedItem;
    let blankListitem = this.createBlankListitem();
    blankListitem.setAttribute("emptyrow", true);

    if (node && node.tagName == "listitem")
      this.headerMapListBox.insertBefore(blankListitem, node.nextSibling);
    else
      this.headerMapListBox.appendChild(blankListitem);

    this.headerMapListBox.setAttribute("hasemptyrow", true);
    this.headerMapListBox.suppressOnSelect = true;
    this.headerMapListBox.selectItem(blankListitem);
    this.headerMapListBox.suppressOnSelect = false;
    this.headerMapListBox.ensureElementIsVisible(blankListitem);
  },

  createBlankListitem: function() {
this.TM.u.log.debug("TM.Preferences.createBlankListitem: START ");
    let headerListitem = document.createElementNS(this.TM.v.XUL_NS, "listitem");
    headerListitem.setAttribute("allowevents", true);
    let headersCell = document.createElementNS(this.TM.v.XUL_NS, "listcell");
    headersCell.setAttribute("flex", "1");
    let headersCellBox = document.createElementNS(this.TM.v.XUL_NS, "hbox");
    headersCellBox.classList.add("headersCellHeadersBox");
    headersCell.appendChild(headersCellBox);
    headerListitem.appendChild(headersCell);
    return headerListitem;
  },

  removeRowOrHeader: function() {
this.TM.u.log.debug("TM.Preferences.removeRowOrHeader: START ");
    let node = this.headerMapListBox.selectedItem;
    if (!node || node.tagName != "listitem")
      return;

    let removedHeaders = [];
    let selectedHeaders = node.querySelectorAll("button[checked]");
    if (!selectedHeaders.length) {
      // Remove all headers if none selected.
      selectedHeaders = node.querySelectorAll("button");
      for (let selectedHeader of selectedHeaders)
        removedHeaders.push(selectedHeader.label);
      this.removeRow(node);
    }
    else {
      for (let selectedHeader of selectedHeaders) {
        removedHeaders.push(selectedHeader.label);
        selectedHeader.remove();
      }

      if (!node.firstChild.firstChild.hasChildNodes())
        // This row is now empty.
        this.handleEmptyRow(node);
    }

    // Set mapped flag to false if a header is completely removed from the
    // map and make the tree reflect the status.
    let gotOne = false;
this.TM.u.log.debug("TM.Preferences.removeRowOrHeader: removedHeaders "+removedHeaders);
    for (let headerName of removedHeaders) {
      let anyMapped = this.headerMapListBox
                          .querySelectorAll('button[label="' + headerName + '"]');
      if (anyMapped.length == 0) {
        let [headerCategory, headerValue] = this.getHeaderValue(headerName);
        if (headerCategory) {
          // If not already deleted from tree.
          headerValue[this.TM.v.kMapped] = false;
          headerValue[this.TM.v.kDisplayName] = "";
          gotOne = true;
        }
      }
    }

    if (gotOne)
      this.treeBox.invalidate();

//    this.updateButtonState();
    this.d("undoButton").removeAttribute("disabled");
  },

  removeRow: function(aNode) {
this.TM.u.log.debug("TM.Preferences.removeRow: START ");
    let selectNode;
    let node = aNode;
    if (!node || node.tagName != "listitem")
      return;

    if (node.parentNode.currentIndex != 0 ||
        node.nextSibling || !node.selected) {
      // Remove a row if it's not the only one or an unselected empty row.
      if (node.selected && node.hasAttribute("emptyrow"))
        this.headerMapListBox.removeAttribute("hasemptyrow");
      if (node.selected) {
        selectNode = node.parentNode.lastChild == node ? node.previousSibling :
                                                         node.nextSibling;
        node.parentNode.suppressOnSelect = true;
        node.parentNode.selectItem(selectNode);
        node.parentNode.suppressOnSelect = false;
      }
      node.remove();
    }
    else {
      // Remove all of the only row's items.
      let box = node.firstChild.firstChild;
      while (box.lastChild)
        box.lastChild.remove();
      // This is the new empty row.  Update states.
      node.setAttribute("emptyrow", true);
      this.headerMapListBox.setAttribute("hasemptyrow", true);
      this.updateButtonState();
    }
  },

  handleEmptyRow: function(aNode) {
this.TM.u.log.debug("TM.Preferences.handleEmptyRow: START hasemptyrow - "+
                    this.headerMapListBox.hasAttribute("hasemptyrow"));
    if (this.headerMapListBox.hasAttribute("hasemptyrow"))
      // An empty row exists, remove this one.  Can only have 1 empty row.
      this.removeRow(aNode);
    else {
      // This is the new empty row.  Update states.
      this.headerMapListBox.setAttribute("hasemptyrow", true);
      aNode.setAttribute("emptyrow", true);
    }

    this.updateButtonState();
  },

  setHeaderType: function() {
this.TM.u.log.debug("TM.Preferences.setHeaderType: START ");
    let formatCol = this.d("formatCol");
    let menulist = this.d("headerMessageTypeMenuList");
    this.headersTree.setAttribute("hidewrapellipsis", true);
    this.headersTree.setAttribute("hideformat", true);
    if (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE]) {
      menulist.disabled = true;
      this.headersTree.removeAttribute("hideformat");
      formatCol.setAttribute("label", formatCol.getAttribute("labelcompose"));
      formatCol.setAttribute("tooltiptext", formatCol.getAttribute("tooltiptextcompose"));
//this.TM.u.log.debug("TM.Preferences.onSelectHeaderType: compose - "+menulist.selectedItem.value);
    }
    else {
      if (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.BRIEF] ||
          this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.BASIC]) {
        this.headersTree.removeAttribute("hidewrapellipsis");
        this.headersTree.removeAttribute("hideformat");
      }

      menulist.disabled = false;
      formatCol.setAttribute("label", formatCol.getAttribute("labeldefault"));
      formatCol.setAttribute("tooltiptext", formatCol.getAttribute("tooltiptextdefault"));
    }

    if (this.TM.u.g("mrActive").getAttribute("disabled") == "false")
      this.d("headerTypeMenuItemListMultirow").removeAttribute("disabled");
  },

  onSelectHeaderType: function() {
this.TM.u.log.debug("TM.Preferences.onSelectHeaderType: START ");
    TM.Preferences.setHeaderType();
    TM.Preferences.onUndo("headerType");
  },

  onRestore: function() {
this.TM.u.log.debug("TM.Preferences.onRestore: START ");
    // Clear pref for auto rebuild from default.
    let prefName =  "headerMap" + this.messageType + "Pref";
    Services.prefs.clearUserPref(this.TM.v[prefName]);

    this._headerMap = null;
    this._headerMapDefault = null;
    this.categories.map(headerCategory => this[headerCategory] = null);
this.TM.u.log.debug("TM.Preferences.onRestore: default map "+this.headerMap.toSource());

    this.createMap();
    this.onApply();
    this.headerMapListBox.removeAttribute("hasemptyrow");
    this.treeBox.invalidate();
  },

  onUndo: function(aWhat) {
this.TM.u.log.debug("TM.Preferences.onUndo: START ");
    this._headerMap = null;
    this._headerMapDefault = null;
    this.categories.map(headerCategory => this[headerCategory] = null);

    this.createMap();
    this.treeBox.invalidate();
    if (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.LIST] ||
        this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.LISTMR])
      this.TM.u.mainWindow.GetThreadTree().treeBoxObject.invalidate();

    this.updateButtonState();
  },

  onApply: function(aClose) {
    // Create the new map and store it.  Reload headers in the current message.
this.TM.u.log.debug("TM.Preferences.onApply: START ");
    let rowName, headerName, headerValue;
    let map = this.headerMap;
    let rowDesc = "row";
    let row = 0;
    map[this.headerType] = {};
    for (let listitem of this.headerMapListBox.querySelectorAll("listitem")) {
      let buttons = listitem.querySelectorAll("button");
      if (buttons.length > 0) {
        rowName = rowDesc + (++row);
        map[this.headerType][rowName] = {};
        for (let button of buttons) {
          headerName = button.label;
this.TM.u.log.trace("TM.Preferences.onApply: row:headerName "+rowName+":"+headerName);
          [, headerValue] = this.getHeaderValue(headerName);
          if (!headerValue)
            continue;
          headerValue.splice(this.TM.v.kMapped, 1);
          map[this.headerType][rowName][headerName] = headerValue;
        }
      }
    };

    // Last empty row.
    rowName = rowDesc + (++row);
    map[this.headerType][rowName] = {};

    this.d("undoButton").setAttribute("disabled", true);
this.TM.u.log.debug("TM.Preferences.onApply: new map "+map.toSource());

    // Update prefs.
    this.TM.u.HEADER_SEP        = this.d("separatorChar").value;
    this.TM.u.HEADER_WRAP_LINES = this.d("wrapLines").value;
    this.TM.u.setWrapLinesAndBorder();

    // Save the headers map.
    this.TM.u.setHeaderMap(this.messageType, map);
    // Initiate a headers rebuild.
    this.TM.resetHeaderFlags();
    this.TM.Headers.toggle();
    if (!aClose)
      this.onUndo();
  },

  fixIdioticForcedScrollHidden: function() {
this.TM.u.log.trace("TM.Preferences.fixIdioticForcedScrollHidden: START ");
    let listboxbody, rules, rule;
//    let listitem = this.headerMapListBox.querySelector("listitem");
//    listboxbody = listitem.boxBoject.parentBox;
    let nodes = document.getAnonymousNodes(this.headerMapListBox);
    for (let node of nodes) {
      if (node.localName == "listrows" &&
          node.lastChild.localName == "listboxbody") {
        listboxbody = node.lastChild;
        break;
      }
    }

    if (!listboxbody)
      return;

    // Because this would be just too fricken easy.
    // listboxbody.style.removeProperty("overflow-x");

    let domSvc = Components.classes["@mozilla.org/inspector/dom-utils;1"]
                           .getService(Components.interfaces["inIDOMUtils"]);
    rules = domSvc.getCSSStyleRules(listboxbody);
    for (let j = 0; j < rules.Count(); j++) {
      rule = rules.GetElementAt(j);
      if (rule.selectorText == "listboxbody") {
        rule.QueryInterface(Components.interfaces.nsIDOMCSSStyleRule)
            .style.removeProperty("overflow-x");
this.TM.u.log.debug("TM.Preferences.fixIdioticForcedScrollHidden: fixed - "+rule.cssText);
      }
    }
  },

/* Headers tree functions *****************************************************/

  categories: ["commonHeaders", "collectedHeaders", "customHeaders", "otherValues"],

  // Indices of visibleArray array.
  kName:         0,
  kIsContainer:  1,
  kIsOpen:       2,
  kCategoryName: 3,
  kOpenBit:      4,

  visibleArray: [
    // ["Name String", isContainer, isOpen, "children category map name"]
    ["commonHeadersStr", true, false, "commonHeaders", 1],
    ["collectedHeadersStr", true, false, "collectedHeaders", 2],
    ["otherValuesStr", true, false, "otherValues", 4],
    ["customHeadersStr", true, false, "customHeaders", 8]
  ],

  // [Wraplines, Ellipsis, Format, Display Name Override, isMapped]
  headerValueTemplate: [0, true, "", "", false],

  onKeyPress: function(aEvent) {
    // |which| is either the charCode or the keyCode, depending on which is set.
this.TM.u.log.debug("TM.Preferences.onKeyPress: START which:charCode:keyCode:key - "+
                    aEvent.which+":"+aEvent.charCode+":"+aEvent.keyCode+":"+aEvent.key);
    if (aEvent.altKey || aEvent.metaKey || aEvent.ctrlKey)
      return;

    let headerCategory, headerName, headerValue, col;
    let row = this.headersTree.currentIndex;
    if (this.headersTree.hasAttribute("editing")) {
      headerName = this.visibleArray[this.headersTree._editingRow][this.kName];
      [, headerValue] = this.getHeaderValue(headerName);
      if (this.headersTree._editingColumn &&
          (this.headersTree._editingColumn.id == "nameCol" ||
           (this.headersTree._editingColumn.id == "displayNameCol" &&
            this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE]))) {
        // Per RFC5322, header name (email) chars must be printable ascii
        // chars d'33' to d'126' minus the colon d'58'.  So edit check if
        // editing headerName column, and also displayName column if mapping
        // header type 'compose'.
this.TM.u.log.debug("TM.Preferences.onKeyPress: editing ");
        aEvent.stopPropagation();
        if (!this.hasValidChar(aEvent.key) && !aEvent.keyCode)
          aEvent.preventDefault();
      }

      return;
    }

    if (aEvent.key == this["editDiplayNameKey"]) {
      col = this.headersTree.columns.getNamedColumn("displayNameCol");
      this.headersTree.startEditing(row, col);
      return;
    }
    else if (aEvent.key == this["editFormatKey"]) {
      col = this.headersTree.columns.getNamedColumn("formatCol");
      if (col.disabled || this.getCellProperties(row, col).contains("unMapped"))
        return;
      this.openFormatPopup(row, col);
      this.headersTree.startEditing(row, col);
      return;
    }
    else if (aEvent.key == " " || aEvent.key == KeyEvent.DOM_VK_RIGHT) {
      this.addHeaderToMap();
      return;
    }
    else if (aEvent.key == KeyEvent.DOM_VK_RETURN) {
      aEvent.preventDefault();
      this.addHeaderToMap();
      return;
    }
    else {
      headerName = this.visibleArray[row][this.kName];
      [headerCategory, headerValue] = this.getHeaderValue(headerName);
      if (aEvent.key == this["toggleWrapKey"]) {
        headerValue[this.TM.v.kWrapLines] = headerValue[this.TM.v.kWrapLines] ? 0 : 1;
        this.treeBox.invalidateRow(row);
      }
      else if (aEvent.key == this["toggleEllipsisKey"]) {
        headerValue[this.TM.v.kEllipsis] = !headerValue[this.TM.v.kEllipsis];
        this.treeBox.invalidateRow(row);
      }
    }
  },

  onInput: function(aEvent) {
    let inputField = aEvent.target._inputField;
    let val = inputField.value;
    let index = val.indexOf(" ");
    if (index == -1)
      return;
this.TM.u.log.debug("TM.Preferences.onInput: spacehit val:index - "+val+":"+index);
    inputField.value = val.replace(/\s/g, "\u2420"); //"␠"
this.TM.u.log.debug("TM.Preferences.onInput: inputField.value - "+inputField.value);
    inputField.selectionStart = inputField.selectionEnd = index + 1;
  },

  hasValidChar: function (aStr) {
    function validChar(e) {
      return e.charCodeAt(0) != 58 &&
             e.charCodeAt(0) >= 33 &&
             e.charCodeAt(0) <= 126;
    }

    return Array.every(aStr, validChar);
  },

  getRowForCategory: function(aCategory) {
    let r;
    let lastRow = this.headersTree.view.rowCount - 1;
    for (r = lastRow; r >= 0; r--) {
      if (this.getLevel(r) == 0 &&
          this.visibleArray[r][this.kCategoryName] == aCategory)
        break;
    }

    return r;
  },

  openFormatPopup: function(aRow, aCol) {
    let textX = {}, textY = {};
    // Offsets for positioning the popup.
    let  x = this.treeBox.screenX - window.mozInnerScreenX;
    // Don't forget the titlebar..
    let  y = this.treeBox.screenY - window.screenY;
    this.treeBox.getCoordsForCellItem(aRow+1, aCol, "text", textX, textY, {}, {});
    this.d("headerMessageFormatPopup").openPopup(null, null,
                                                 textX.value + x,
                                                 textY.value + y,
                                                 false, false);
  },

  setFormat: function(aValue) {
this.TM.u.log.debug("TM.Preferences.setFormat: START "+aValue);
    if (aValue && this.TM.v.HEADER.FORMAT_TYPES.has(aValue)) {
      let row = this.headersTree.currentIndex;
      let headerName = this.visibleArray[row][this.kName];
      let [, headerValue] = this.getHeaderValue(headerName);
      headerValue[this.TM.v.kFormat] = aValue;
      this.treeBox.invalidateRow(row);
    }

    this.headersTree.focus();
  },
/*
  handleComposeColSelect: function(aHeaderName) {
this.TM.u.log.debug("TM.Preferences.handleComposeColSelect: START - "+aHeaderName);
    let headerName = aHeaderName;
    let [headerCategory, headerValue] = this.getHeaderValue(headerName);
    let val = headerValue[this.TM.v.kComposeHeader];
    this[headerCategory][headerName][this.TM.v.kComposeHeader] = !val;
    let newComposeMap = this.headerMapCompose;
    if (val) {
      delete newComposeMap[headerName];
      this._headerMapCompose = newComposeMap;
    }
    else {
      let curDisplayName = this.headerMapCompose[headerName] ?
                               this.headerMapCompose[headerName][0] :
                               "";
      let displayName = "";
      if (headerCategory != this.categories[0]) {
        // If not commonHeaders (have strings for those) autofill a name.
        displayName = headerName.toString();
        displayName = displayName.substr(0,1).toUpperCase() +
                      displayName.substr(1);
      }
      newComposeMap[headerName] = curDisplayName ? [curDisplayName] :
                                                   [displayName];
      this._headerMapCompose = newComposeMap;
    }
  },
*/
  getHeadersCategory: function(aCategory) {
//this.TM.u.log.debug("getHeadersCategory: START "+aCategory);
    if (this[aCategory])
      return;
this.TM.u.log.debug("TM.Preferences.getHeadersCategory: "+aCategory+":"+
                    JSON.stringify([...this.TM.u[aCategory]]));
    let map = new Map();
    // Seed the map with default values.
    for (let headerName of this.TM.u[aCategory].keys()) {
//this.TM.u.log.debug("TM.Preferences.getHeadersCategory: headerName "+ headerName);
      map.set(headerName, [].concat(this.headerValueTemplate));
    }

    // Apply values from the default map for this message type and header type.
    for (let [rowName, headerRow] in Iterator(this.headerMapDefault[this.headerType])) {
      for (let [headerName, headerValue] in Iterator(headerRow))
        if (map.has(headerName)) {
          headerValue[this.TM.v.kMapped] = false;
          map.set(headerName, headerValue);
        }
    }

    // Finally apply values from the user configured map for this message type
    // and header type.
    for (let [rowName, headerRow] in Iterator(this.headerMap[this.headerType])) {
      for (let [headerName, headerValue] in Iterator(headerRow))
        if (map.has(headerName)) {
          headerValue[this.TM.v.kMapped] = true;
          map.set(headerName, headerValue);
        }
    }
this.TM.u.log.debug("TM.Preferences.getHeadersCategory: map "+
                    JSON.stringify([...map]));

    this[aCategory] = map;
  },

  getHeaderValue: function(aHeaderName) {
//this.TM.u.log.debug("getHeaderValue: START "+aHeaderName);
    // Find the header's values in one of the categories.
    let headerValue, category;
    for (let headerCategory of this.categories) {
      if (this[headerCategory].has(aHeaderName)) {
        category = headerCategory;
        headerValue = this[headerCategory].get(aHeaderName);
        break;
      }
    }

    return [category, headerValue];
  },

  headerExists: function(aHeaderName) {
    // Find the header's values in one of the categories.
    for (let headerCategory of this.categories) {
      if (this[headerCategory].has(aHeaderName))
        return true;
    }

    return false;
  },

/* nsITreeView implementation *************************************************/

  treeBox: null,
  selection: null,
  get rowCount()                         { return this.visibleArray.length; },
  setTree: function(aTreebox)            { this.treeBox = aTreebox; },
  isContainerOpen: function(aRow)        { return this.visibleArray[aRow][this.kIsOpen]; },
  isContainerEmpty: function(aRow)       { return false; },
  isSeparator: function(aRow)            { return false; },
  isSorted: function()                   { return false; },
  isSelectable: function(aRow, aColumn)  { return false; },

  getImageSrc: function(aRow, aCol)      { return null; },
  getProgressMode : function(aRow, aCol) {},
  cycleHeader: function(aCol)            {},
  cycleCell: function(aRow, aCol)        {},
  selectionChanged: function()           {},
  performAction: function(aAction)       {},
  performActionOnCell: function(aAction, aRow, aCol) {},
  getRowProperties: function(aRow)       { return ""; },
  getColumnProperties: function(aCol)    { return ""; },

  isContainer: function(aRow)            {
    return aRow > this.rowCount ? false : this.visibleArray[aRow][this.kIsContainer];
  },

  getCellProperties: function(aRow, aCol) {
    let props = [];
    if (!this.isContainer(aRow)) {
      let headerName = this.visibleArray[aRow][this.kName];
      let [headerCategory, headerValue] = this.getHeaderValue(headerName);
//this.TM.u.log.debug("getCellProperties: headerCategory:headerName:headerValue - "+
//                    headerCategory+":"+headerName+":"+headerValue);

      if (aCol.id == "nameCol")
        props.push("headerNameCol");
      if (aCol.id == "displayNameCol")
        props.push("displayNameCol");

      if (!headerValue ||
          !headerValue[this.TM.v.kMapped] ||
          aCol.id == "customColumnCol") {
        // Header not in a map, or inapplicable column.
        props.push("unMapped");
      }

      if (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE] &&
          aCol.id != "nameCol" && aCol.id != "displayNameCol" &&
          aCol.id != "formatCol") {
        // Compose is special.
        props.push("unMapped");
      }

      if (this.headerType != this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE] &&
          aCol.id == "formatCol" && headerName == "tags") {
        // No tags format.
        props.push("unMapped");
      }

      if ((this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.LIST] ||
           this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.LISTMR]) &&
          aCol.id != "nameCol" && aCol.id != "displayNameCol") {
        // List is special.
        props.push("unMapped");
      }
    }

    return props.join(" ");
  },

  getCellText: function(aRow, aCol) {
    if (aRow >= this.visibleArray.length)
      return null;
//this.TM.u.log.debug("TM.Preferences.getCellText: row - "+aRow);
    let headerName = this.visibleArray[aRow][this.kName];
    if (this.isContainer(aRow)) {
      if (aCol.id == "nameCol")
        // A string.
        return this[headerName];
      else
        return null;
    }

    let headerValueIndex;
    if (aCol.id == "nameCol")
      return headerName;
    if (aCol.id == "displayNameCol")
      headerValueIndex = this.TM.v.kDisplayName;
    else if (aCol.id == "formatCol")
      headerValueIndex = this.TM.v.kFormat;
    else
      return null;

    let [headerCategory, headerValue] = this.getHeaderValue(headerName);
    if (!headerValue)
      return null;

    if (headerValueIndex == this.TM.v.kFormat) {
      if (headerValue[this.TM.v.kMapped] && headerValue[headerValueIndex]) {
        if (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE])
          // Get the default compose value.
          return headerValue[headerValueIndex].replace(/\s/g, "\u2420"); //"␠"
        else
          // Get the string for the format token, if exists.
          return this[headerValue[headerValueIndex] + "Str"];
      }
    }

    if (headerValueIndex == this.TM.v.kDisplayName) {
      if (headerValue[headerValueIndex])
        // A customized value.
        return headerValue[headerValueIndex].replace(/\s/g, "\u2420"); //"␠"
      if (headerValue[headerValueIndex] === null)
        // User no want.
        return null;

      // Show special case overrides, or dtd names, or nothing.
      let commonHeaderName = this.TM.u["commonHeaders"].get(headerName);
      commonHeaderName = commonHeaderName ? commonHeaderName[this.TM.v.kLabelValue] : null;
      let otherValuesName = this.TM.u["otherValues"].get(headerName);
      otherValuesName = otherValuesName ? otherValuesName[this.TM.v.kLabelValue] : null;
      let displayName = this.TM.headerDisplaySpecial(this.messageType, headerName) ||
                        commonHeaderName || otherValuesName || null;
      let sep = this.headerType != this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE] ?
                  this.TM.u.HEADER_SEP : "";
      let sepL = "", sepR = "";
      this.TM.u.isRtl ? sepL = sep : sepR = sep;
      return displayName ? sepL + displayName + sepR : null;
    }

    return null;
  },

  getCellValue: function(aRow, aCol) {
    if (this.isContainer(aRow))
      return null;

    let headerValueIndex;
    if (aCol.id == "wrapCol")
      headerValueIndex = this.TM.v.kWrapLines;
    else if (aCol.id == "ellipsisCol")
      headerValueIndex = this.TM.v.kEllipsis;
    else
      return null;

    let headerName = this.visibleArray[aRow][this.kName];
    let [headerCategory, headerValue] = this.getHeaderValue(headerName);
    return headerValue ? headerValue[headerValueIndex] ? true : false : null;
  },

  getParentIndex: function(aRow) {
    if (this.isContainer(aRow))
      return -1;
    for (let t = aRow - 1; t >= 0 ; t--) {
      if (this.isContainer(t))
        return t;
    }
    return -1;
  },

  getLevel: function(aRow) {
    if (this.isContainer(aRow))
      return 0;
    return 1;
  },

  isEditable: function(aRow, aCol) {
this.TM.u.log.debug("TM.Preferences.isEditable: "+aRow);
    if (this.isContainer(aRow))
      return false;

    if (aCol.id == "nameCol" && this.isNameColEditable)
      // Custom header is being added.  The row is always added at the bottom,
      // and is not editable once it's added.
      return true;

    if (aCol.id != "displayNameCol" && aCol.id != "formatCol")
      return false;

    let headerName = this.visibleArray[aRow][this.kName];

    // Non compose tags header values don't apply.
    if (aCol.id == "formatCol" &&
        (this.headerType != this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE] &&
         headerName == "tags"))
      return false;

    let [headerCategory, headerValue] = this.getHeaderValue(headerName);
    if (!headerValue || !headerValue[this.TM.v.kMapped])
      return false;

    if (aCol.id == "formatCol") {
      if (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE]) {
        setTimeout(function() {
          let headersTree = TM.Preferences.headersTree;
          let input = headersTree.inputField;
          let left = input.left - aCol.getPrevious().element.boxObject.width;
          let width = 20; //headersTree.firstChild.boxObject.lastChild.boxObject.width;
          let col = aCol.getPrevious();
          for (col; col; col = col.getNext()) {
TM.Preferences.TM.u.log.debug("TM.Preferences.isEditable: width - " +width);
            width += col.element.boxObject.width;
          }

          input.setAttribute("left", left);
          input.setAttribute("width", width);
TM.Preferences.TM.u.log.debug("TM.Preferences.isEditable: left:width - "+ left+":"+width);
        }, 40);
      }
      else {
        this.openFormatPopup(aRow, aCol);
      }
    }

    return true;
  },

  setCellText: function(aRow, aCol, aText) {
this.TM.u.log.debug("TM.Preferences.setCellText: row:text - "+aRow+":"+aText);
    // Here only if in editor, and in a column that is editable.
    let headerName = this.visibleArray[aRow][this.kName];
    let [headerCategory, headerValue] = this.getHeaderValue(headerName);

    if (aCol.id == "nameCol") {
      // New custom header. Remove placeholder row.
      this.deleteHeader(headerName);
      if (aText)
        // If entered a name, lowercase it and add it.
        this.addHeader(aText.toLowerCase());
    }

    if (aCol.id == "displayNameCol" &&
        aText != this.getCellText(aRow, aCol)) {
      // The display name for headers.  Compose is strict rfc.
      if (this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE]) {
        if (this.hasValidChar(aText))
          headerValue[this.TM.v.kDisplayName] = aText;
        else
          this.treeBox.invalidateRow(aRow);
      }
      else {
        let text = aText.replace(/\u2420/g, " "); //"␠"
        headerValue[this.TM.v.kDisplayName] = text || null;
      }
    }

    if (aCol.id == "formatCol" &&
        this.headerType == this.TM.v.HEADER[this.TM.v.HEADER.COMPOSE])
      headerValue[this.TM.v.kFormat] = aText.replace(/\u2420/g, " "); //"␠"

this.TM.u.log.debug("TM.Preferences.setCellText: new headerCategory:headerName:headerValue - "+
                    headerCategory+":"+headerName+":"+headerValue);

    this.isNameColEditable = false;
    this.headersTree.focus();
  },

  hasNextSibling: function(aRow, aAfterIndex) {
    let thisLevel = this.getLevel(aRow);
    for (let t = aAfterIndex + 1; t < this.visibleArray.length; t++) {
      let nextLevel = this.getLevel(t);
      if (nextLevel == thisLevel)
        return true;
      if (nextLevel < thisLevel)
        break;
    }
    return false;
  },

  toggleOpenState: function(aRow) {
    let item = this.visibleArray[aRow];
    if (!item[this.kIsContainer])
      return;

    if (item[this.kIsOpen]) {
      item[this.kIsOpen] = false;

      let thisLevel = this.getLevel(aRow);
      let deletecount = 0;
      for (let t = aRow + 1; t < this.visibleArray.length; t++) {
        if (this.getLevel(t) > thisLevel)
          deletecount++;
        else
          break;
      }
      if (deletecount) {
        this.visibleArray.splice(aRow + 1, deletecount);
        this.treeBox.rowCountChanged(aRow + 1, -deletecount);
      }
    }
    else {
      item[this.kIsOpen] = true;

      let headerCategory = this.visibleArray[aRow][this.kCategoryName];
      let headers = [...this[headerCategory].keys()];
this.TM.u.log.debug("TM.Preferences.toggleOpenState: "+headerCategory+":"+headers);
      for (let i = 0; i < headers.length; i++)
        this.visibleArray.splice(aRow + i + 1, 0, [headers[i], false]);
      this.treeBox.rowCountChanged(aRow + 1, headers.length);
    }
    this.treeBox.invalidateRow(aRow);
    this.setOpenState();
  }

}
